io.stdout:setvbuf("no")

local display = require 'display'
local options = require 'options'

local map = nil
local x, y, speed = 128, 128, 300
local lg = love.graphics
local bg = lg.newImage('sonic.gif')
local screen = {1024, 768, 640, 448, false, false, {fullscreen = false, vsync = true, fsaa = 2}}

function love.load()
    display.setScreen(unpack(screen))
    love.window.setTitle('Scaler Test')
    options:load()
end

function love.draw()
    display.set()
    lg.draw(bg)
    display.unset()
    -- Display configurator outside of scaler
    lg.push()
        w, h = unpack(screen)
        lg.translate(0, 0)
        lg.scale(1,1)
        lg.setScissor(0, 0, w, h)
        options:draw()
    lg.pop()
end

function love.update(dt)
    options:update(dt)
end
function love.mousepressed(x, y, button)
    options:mousepressed(x, y, button)
end
function love.mousereleased(x, y, button)
    options:mousereleased(x, y, button)
end
function love.keypressed(key, unicode)
    options:keypressed(key, unicode)
end
function love.keyreleased(key)
    options:keyreleased(key)
end
function love.textinput(text)
    options:textinput(text)
end

    -- if key == "f11" then
    --     local _, width, height = display.getCurrent()

    --     if love.window.getFullscreen() then
    --         display.setScreen(unpack(screen))
    --     else
    --         _, _, gw, gh, st, sc, _ = unpack(screen)
    --         display.setScreen(width, height, gw, gh, st, sc, {fullscreen = true, vsync = false})
    --     end
    -- end
